#!/usr/bin/perl

#
# Author: Ahfyth
#

use strict;
use warnings;

if( $#ARGV < 0 )
{
	print STDERR "\nUsage: $0 <file.prefix>\n";
	print STDERR "\nThis program is designed to count the reads in each bin for the target chromosome.\n\n";
	exit 1;
}

my $bin = 2e5;
my $target = 'chr21';

open IN, "$ARGV[0].short.dat" or die( "$!" );
#print STDERR "Loading SHORT ...\n";
my $scount = 0;
my @schr21;
while( <IN> )
{
#	chomp;
	my @l = split /\t/;
	++ $scount;
	$schr21[ int($l[1]/$bin) ] ++ if $l[0] eq $target;
}
close IN;

open IN, "$ARGV[0].long.dat" or die( "$!" );
#print STDERR "Loading LONG ...\n";
my $lcount = 0;
my @lchr21;
while( <IN> )
{
#	chomp;
	my @l = split /\t/;
	++ $lcount;
	$lchr21[ int($l[1]/$bin) ] ++ if $l[0] eq $target;
}
close IN;

#print STDERR "Writing output ...\n";
print "#File prefix: $ARGV[0]\n";
print "#Short count: $scount\n#Long count: $lcount\n";
print "#index\tShortRaw\tShortNorm\tLongRaw\tLongNorm\n";
my $len = $#schr21;
$len = $#lchr21 if $#lchr21 > $#schr21;

my ( $s, $l );
for( my $i=0; $i<=$len; ++$i )
{
	if( defined $schr21[$i] )
	{
		$s = "$schr21[$i]\t";
		$s .= $schr21[$i]/$scount * 1e8;
	}
	else	{ $s = "-\t-"; }
	if(defined $lchr21[$i] )
	{
		$l = "$lchr21[$i]\t";
		$l .= $lchr21[$i]/$lcount * 1e8;
	}
	else	{ $l = "-\t-"; }

	if( "$s$l" =~ /-/ )
	{
		print "#$i\t$s\t$l\n";
	}
	else
	{
		print "$i\t$s\t$l\n";
	}
}

