#!/usr/bin/perl

#
# Author: Ahfyth
#

use strict;
use warnings;

if( $#ARGV < 1 )
{
	print STDERR "\nUsage: $0 <in.file> <out.prefix>\n";
	print STDERR "\nThis program is designed to publish the Trisomy test result.\n\n";
	exit 2;
}

my $infile = $ARGV[0];
my $outpre = $ARGV[1];

## load SHORT/LONG information
open IN, "$outpre.count.dat" or die( "$!" );
<IN>;
my $result = <IN>;
$result =~ /(\d+)/;
my $short = $1;
$result = <IN>;
$result =~ /(\d+)/;
my $long = $1;
close IN;

## load P value
open IN, "$outpre.pvalue" or die( "$!" );
$result = <IN>;
chomp( $result );
my @l = split /\t/, $result;
my $pvalue = $l[1];
close IN;
my $logp = -log($pvalue)/log(10);

## make report
my $cutoff = 3;
$result = ( $logp > $cutoff ) ? 'Trisomy' : 'Euploidy';

printf "#File\tSHORT\tLONG\tP-value\t-log(P)\tStatus\n%s\t%d\t%d\t%.4g\t%.4g\t%s\n",
	   $infile, $short, $long, $pvalue, $logp, $result;

